stages:
  - .pre
  - deploy

gitversion:
  image: 
    name: gittools/gitversion
    entrypoint: [""]
  stage: .pre    
  variables:
    GIT_STRATEGY: fetch
    GIT_DEPTH: 0 # force a deep/non-shallow fetch need by gitversion
  cache: [] # caches and before / after scripts can mess things up
  before_script: []
  after_script: []
  script:
    - |
      /tools/dotnet-gitversion /output buildserver $VERBOSITYSETTING
      # We could just collect the output file gitversion.properties (with artifacts:report:dotenv: gitversion.properties as it is already in DOTENV format, 
      # however it contains ~33 variables which unnecessarily consumes many of the 50 max DOTENV variables of the free GitLab version.
      # Limits are higher for licensed editions, see https://docs.gitlab.com/ee/ci/yaml/artifacts_reports.html#artifactsreportsdotenv
      grep 'GitVersion_LegacySemVer='          gitversion.properties >> thisversion.env
      grep 'GitVersion_SemVer='          gitversion.properties >> thisversion.env
      grep 'GitVersion_FullSemVer='      gitversion.properties >> thisversion.env
      grep 'GitVersion_Major='           gitversion.properties >> thisversion.env
      grep 'GitVersion_Minor='           gitversion.properties >> thisversion.env
      grep 'GitVersion_Patch='           gitversion.properties >> thisversion.env
      grep 'GitVersion_MajorMinorPatch=' gitversion.properties >> thisversion.env
  artifacts:
    reports:
      #propagates variables into the pipeline level
      dotenv: thisversion.env

package:
  image: mcr.microsoft.com/dotnet/sdk:8.0
  stage: deploy
  script:
    - |
      echo "${GitVersion_LegacySemVer}"     
      dotnet pack -p:Version=${GitVersion_LegacySemVer} -c Release
      dotnet nuget add source "$CI_SERVER_URL/api/v4/projects/$CI_PROJECT_ID/packages/nuget/index.json" --name gitlab --username gitlab-ci-token --password $CI_JOB_TOKEN --store-password-in-clear-text
      echo "Pushing package to registry."      
      dotnet nuget push "$CI_PROJECT_DIR/DCP.Migration/bin/Release/*.nupkg" --source gitlab --no-symbols
